package com.yh.saas.plugin.yiliangyiyun.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.yh.saas.plugin.yiliangyiyun.entity.ContractManagementInfo;
import com.yh.saas.plugin.yiliangyiyun.entity.PaymentManagement;
import com.baomidou.mybatisplus.service.IService;
import com.yh.saas.plugin.yiliangyiyun.entity.view.PaymentView;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * <p>
 * 付款管理 服务类
 * </p>
 *
 * @author Gdc
 * @since 2021-09-06
 */
public interface IPaymentManagementService extends IService<PaymentManagement> {
    /**
     * 付款管理列表
     * @param paymentManagement
     */
    Page<PaymentManagement> selectPaymentManagement(PaymentManagement paymentManagement);

    /**
     * 查看
     *
     * @param
     */
    PaymentManagement getInfo(String id);
    /**
     * 结算
     *
     * @param paymentManagement
     */
    String editInfo(PaymentManagement paymentManagement);
    /**
     * 付款
     * @param paymentManagement
     */
    String payMoney(PaymentManagement paymentManagement);
    /**
     * 收款
     * @param paymentManagement
     */
    String collectMoney(PaymentManagement paymentManagement);
    /**
     * 备注
     * @param paymentManagement
     */
    String addRemarks(PaymentManagement paymentManagement);
    /**
     * 编辑应收
     * @param paymentManagement
     */
    String editCollect(PaymentManagement paymentManagement);
    /**
     * 合同编号下拉列表
     *
     * @param compId
     */
    List<ContractManagementInfo> selectContractNoList(String compId);

    /**
     * 删除
     *
     * @param id
     */
    void deleteInfo(String id);
    /**
     * 查客户对应货名当年累积量
     * @param paymentManagement
     * @return
     */
    Float cumulant(PaymentManagement paymentManagement);
    /**
     * 结算开启审核流
     * @param paymentManagement
     * @return
     */
    String openAuditFlow(PaymentManagement paymentManagement);
    /**
     * 查数据有没有taskId
     * @param paymentManagement
     * @return
     */
    String selectTaskId(PaymentManagement paymentManagement);
    /**
     * 反结算
     *
     * @param paymentManagement
     */
    String ReSettlement(PaymentManagement paymentManagement);

    void export(PaymentManagement paymentManagement, HttpServletResponse response) throws Exception;

    /**
     * 手机审核文件下载
     * @param paymentManagement
     * @param response
     * @throws Exception
     */
    String exportPhone(PaymentManagement paymentManagement, HttpServletResponse response) throws Exception;

    /**
     * 手机审核数据
     * @param paymentManagement
     * @param
     * @throws Exception
     */
    PaymentView exportPhoneData(PaymentManagement paymentManagement);
}
